#pragma once

#include "DirectX.h"
#include "Texture.h"


#define FVF_SIMPLE_2D		(D3DFVF_XYZRHW | D3DFVF_DIFFUSE)
#define FVF_SIMPLE_TEX_2D   (D3DFVF_XYZRHW | D3DFVF_DIFFUSE | D3DFVF_TEX1)


// VvȃeNX`\t_
struct Simple2DVertex
{
	DirectX::XMFLOAT3 position;
	DirectX::XMFLOAT2 uv;
};


//	XvCgNX
class Sprite
{
public:
	Sprite(void);
	~Sprite(void);

	// XvCg̐
	bool Create(const char* pTexturePath = NULL);
	// XvCg̉
	void Finalize(void);


	// XvCg`
	void Render(void);

	// XvCg̍Wݒ
	void SetPos(float x, float y);
	// XvCg̃TCYݒ
	void SetSize(float width, float height);
	// XvCg̉]ݒ
	void SetRotation(float angle);
	// XvCǧ_ݒ
	void SetOrigin(float x, float y);
	// XvCgUVݒ
	void SetUV(int u, int v, int width, int height);
	// XvCg̃J[ݒ
	void SetColor(DWORD color);

	// XvCg̍W擾
	float GetX(void) const { return m_x; }
	float GetY(void) const { return m_y; }

	// XvCg̃TCY擾
	float GetWidth(void) const { return m_width; }
	float GetHeight(void) const { return m_height; }

	// XvCg̉]ݒ
	float GetRotation(void) const { return m_angle; }

	// XvCǧ_ݒ
	float GetOriginX(void) const { return m_cx; }
	float GetOriginY(void) const { return m_cy; }

	// XvCgUV擾
	float GetU(void) const { return m_u1; }
	float GetV(void) const { return m_v1; }
	float GetUWidth(void) const { return m_u2 - m_u1; }
	float GetVHeight(void) const { return m_v2 - m_v1; }

	// XvCg̃J[ݒ
	DWORD GetColor(void) const { return m_color; }

	// eNX`[̎擾
	Texture* GetTexture(void) { return &m_texture; }

private:
	float		m_x, m_y;
	float		m_width, m_height;
	float		m_u1, m_v1;
	float		m_u2, m_v2;
	float		m_angle;
	float		m_cx, m_cy;
	DWORD		m_color;
	Texture		m_texture;
};

