#pragma once

#include "DirectX.h"
#include "Texture.h"


#define FVF_SIMPLE_3D		(D3DFVF_XYZ | D3DFVF_DIFFUSE)
#define FVF_SIMPLE_TEX_3D   (D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX1)
#define	FVF_MESH_VERTEX		(D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1 | D3DFVF_DIFFUSE);
#define	FVF_MESH_TEX_VERTEX	(D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1 | D3DFVF_DIFFUSE);


// VvȒ_
struct SimpleVertex
{
	float x, y, z;
	DWORD color;
};

// VvȃeNX`\t_
struct SimpleTexVertex
{
	float x, y, z;
	DWORD color;
	float u, v;
};

struct MeshVertex
{
	float x, y, z;
	float nx, ny, nz;
	DWORD color;
	float u, v;

	// XLbVp
	BYTE index[4];
	float weight[4];
};

struct MaterialData
{
	Texture			texture;	// eNX`\
	//D3DMATERIAL9	material;		// }eA
};


// f
struct MeshData
{
	UINT				fvf;			// tH[}bg
	//D3DPRIMITIVETYPE	primType;		// v~eBu̕`@
	UINT				primNum;		// v~eBu
	UINT				vertexNum;		// _
	UINT				vertexStride;	// 1_ӂ̃TCY
	UINT				indexNum;		// CfbNX
	UINT				materialIndex;	// }eAԍ

	VertexBuffer		vertexBuffer;	// v_obt@
	IndexBuffer			indexBuffer;	// CfbNXobt@
};


// fNX
class Model
{
public:
	Model(void);
	~Model(void);


	// 
	bool Initialize(UINT meshNum, UINT materialNum);
	// 
	virtual void Finalize(void);

	// `
	virtual void Render(void);

	// bV̎擾
	UINT GetMeshNum(void) const { return m_meshNum; }
	// }eA̎擾
	UINT GetMaterialNum(void) const { return m_materialNum; }
	// [hs̎擾
	MeshData* GetMesh(UINT i) { return &m_pMesh[i]; }
	// [hs̎擾
	MaterialData* GetMaterial(UINT i) { return &m_pMaterial[i]; }

	// [hs̎擾
	//D3DXMATRIX* GetWorld(void) { return &m_world; }

public:
	// f̐
	bool CreateTriangle(void);
	// f̐
	bool Create3DAxis(bool x = true, bool y = true, bool z = true);
	// f̐
	bool CreateShpere(int divideCount = 24, const char* pTexturePath = NULL);

	// tX^̈敗f(C[t[)̐
	bool CreateViewFrustum(void);
	// Jf(C[t[)̐
	bool CreateCamera(void);


	// ̓蔻
	//int RayPick(const D3DXVECTOR3* pPos, const D3DXVECTOR3* pVec, float* pDist, D3DXVECTOR3* pOut);

private:
	// ̓蔻
	//int RayPick(UINT i, const D3DXVECTOR3* pPos, const D3DXVECTOR3* pVec, D3DXVECTOR3* pOut);
	// ̓蔻
	//bool RayPickTriangle(const D3DXVECTOR3* pTriangle, D3DXVECTOR3 pos, D3DXVECTOR3 vec, D3DXVECTOR3* pOut, float* pDist);

	// }eȀ
	virtual void InitMaterial(void);

protected:
	UINT			m_meshNum;		// bV
	UINT			m_materialNum;	// }eA

	MeshData*		m_pMesh;		// bV
	MaterialData*	m_pMaterial;	// }eA
	//D3DXMATRIX		m_world;		// [h}gbNX
};
