#pragma once

// DirectX12̃wb_[܂߂
#include <d3d12.h>
#include <dxgi1_4.h>
#include <D3Dcompiler.h>
#include <DirectXMath.h>
#include <wrl.h>

using Microsoft::WRL::ComPtr;


#include "GraphicDescriptorHeap.h"

// p̃}N`
#define SAFE_RELEASE(x) { if(x) { (x)->Release(); (x) = NULL; } }
// ACZo
#define	ALIGN(n, align)		(((n) + (align) - 1) & ~((align) - 1))



#define FrameCount 2



// DirectXNX
class DirectX12
{
public:
	// `惂[h
	enum ERenderMode
	{
		Normal,		// 
		Add,		// Z
		Subtract,	// Z
		Multiple,	// Z
	};

	DirectX12(void);
	~DirectX12(void);

	// DirectX̏
	bool Initialize(HWND hWnd, int width, int height, bool isFullscreen);
	// DirectX̏I
	void Finalize(void);

	// `V[̊Jn
	void BeginRenderScene(void);
	// `V[̏I
	void EndRenderScene(void);
	// obNobt@̃NA
	void ClearBackBuffer(float r, float g, float b, float a);
	// ʂ̃tbv
	void FlipDisp(void);

	// ̕`Xe[gݒ
	void SetDefaultRenderState(void);

	// `Xe[g̐ݒ
	void SetRenderMode(ERenderMode mode, bool enableAlpha);

	// D3D12DeviceIuWFNg̎擾
	ComPtr<ID3D12Device>& GetDevice(void) { return m_pDevice; }
	ComPtr<ID3D12GraphicsCommandList>& GetCommandList(void) { return m_pCommandList; }
	ComPtr<ID3D12CommandQueue>& GetCommandQueue(void) { return m_pCommandQueue; }
	GraphicDescriptorHeap& GetGraphicsDescripterHeap() { return m_GraphicDescriptorHeap; }
	void BeginCommand();
	void ExecuteCommand();
	void WaitCommand();
	void TranslationBarrier(ID3D12Resource* pResource, D3D12_RESOURCE_STATES before, D3D12_RESOURCE_STATES after);

private:
	ComPtr<ID3D12Device> m_pDevice;
	ComPtr<IDXGISwapChain3> m_pSwapChain;
	ComPtr<ID3D12DescriptorHeap> m_pRtvHeap;
	ComPtr<ID3D12Resource> m_pRenderTargets[FrameCount];
	ComPtr<ID3D12CommandQueue> m_pCommandQueue;
	ComPtr<ID3D12CommandAllocator> m_pCommandAllocator;
	ComPtr<ID3D12GraphicsCommandList> m_pCommandList;
	ComPtr<ID3D12RootSignature> m_pRootSignature;
	int m_RtvDescriptorSize;
	UINT m_FrameIndex;
	HANDLE m_FenceEvent;
	ComPtr<ID3D12Fence> m_pFence;
	ComPtr<ID3D12PipelineState> m_pPipelineState;
	UINT64 m_FenceValue;
	GraphicDescriptorHeap m_GraphicDescriptorHeap;
	UINT m_Width;
	UINT m_Height;
};



