#include "DirectXLib/DirectXLib.h"


static DirectXLib	Instance;


DirectXLib::DirectXLib(void)
{
}
DirectXLib::~DirectXLib(void)
{
}

// DirectXLib̏
bool DirectXLib::Initialize(const char* pName, int width, int height, bool isFullscreen)
{
	// EBhE̐
	if( !m_window.Create(pName, 0, 0, width, height) )
	{
		return false;
	}
	// DirectXVXȅ
	if( !m_directX.Initialize(m_window.GetHandle(), width, height, isFullscreen) )
	{
		return false;
	}

	// V[VXȅ
	m_sceneManager.Initialize();
	// ̓VXȅ
	m_input.Initialize();

	return true;
}

// DirectXLib̉
void DirectXLib::Finalize(void)
{
	// ̓VXẻ
	m_input.Finalize();
	// V[VXẻ
	m_sceneManager.Finalize();
	// DirectX̉
	m_directX.Finalize();
}

// C[v
void DirectXLib::MainLoop(void)
{
	// C[v
	while( !m_window.IsQuitMessage() )
	{
		if( !m_window.UpdateMessage() )
		{
			// ͂̍XV
			m_input.Update();
			// V[̍XV
			m_sceneManager.Update();

			// `
			{
				m_directX.BeginRenderScene();

				// ʂ̃NA
				m_directX.ClearBackBuffer(0.3f, 0.3f, 0.3f, 0.3f);
				// ftHg`ݒ̐ݒ
				m_directX.SetDefaultRenderState();

				// V[̕`
				m_sceneManager.Render();

				m_directX.EndRenderScene();
			}
			// ʂ̕\
			m_directX.FlipDisp();
		}
	}
}

// DirectXLib̎̒`
DirectXLib DirectXLib::Instance;