#pragma once

#include "Window.h"
#include "DirectX.h"
#include "DrawBuffer.h"
#include "Input.h"
#include "Font.h"
#include "SceneManager.h"
#include "2DHelper.h"
#include "3DHelper.h"



// p̃}N`
#define SAFE_DELETE(x)			{ if(x) { delete (x); (x) = NULL; } }
#define SAFE_DELETE_ARRAY(x)	{ if(x) { delete[] (x); (x) = NULL; } }


// DirectXLibNX
class DirectXLib
{
public:
	DirectXLib(void);
	~DirectXLib(void);

	// DirectXLib̏
	bool Initialize(const char* pName, int width, int height, bool isFullscreen);
	// DirectXLib̉
	void Finalize(void);

	// C[v
	void MainLoop(void);

	// EBhE̎擾
	SimpleWindow* GetWindow(void) { return &m_window; }
	// DirectX̎擾
	DirectX12* GetDirectX(void) { return &m_directX; }
	// Direct3DDevice̎擾
	ComPtr<ID3D12Device>& GetDevice(void) { return m_directX.GetDevice(); }

	// Input̎擾
	Input* GetInput(void) { return &m_input; }
	// SceneManager̎擾
	SceneManager* GetSceneManager(void) { return &m_sceneManager; }

public:
	// DirectXLib̎̒`
	static DirectXLib Instance;

private:
	SimpleWindow	m_window;
	DirectX12		m_directX;
	Input			m_input;
	SceneManager	m_sceneManager;
};


#define	DEBUGFONT		(DirectXLib::Instance.GetDebugFont())
#define	INPUT			(DirectXLib::Instance.GetInput())
#define	SCENEMANAGER	(DirectXLib::Instance.GetSceneManager())
