#include "DirectXLib/DirectXLib.h"


VertexBuffer::VertexBuffer(void)
{}
VertexBuffer::~VertexBuffer(void)
{
	Finalize();
}

// _obt@̐
bool VertexBuffer::Create(UINT size, const void* pVertices)
{
    auto& pDevice = DirectXLib::Instance.GetDevice();


    D3D12_HEAP_PROPERTIES prop;
    prop.Type = D3D12_HEAP_TYPE_UPLOAD;
    prop.CPUPageProperty = D3D12_CPU_PAGE_PROPERTY_UNKNOWN;
    prop.MemoryPoolPreference = D3D12_MEMORY_POOL_UNKNOWN;
    prop.CreationNodeMask = 1;
    prop.VisibleNodeMask = 1;

    D3D12_RESOURCE_DESC resourceDesc;
    resourceDesc.Dimension = D3D12_RESOURCE_DIMENSION_BUFFER;
    resourceDesc.Alignment = 0;
    resourceDesc.Width = size;
    resourceDesc.Height = 1;
    resourceDesc.DepthOrArraySize = 1;
    resourceDesc.MipLevels = 1;
    resourceDesc.Format = DXGI_FORMAT_UNKNOWN;
    resourceDesc.SampleDesc.Count = 1;
    resourceDesc.SampleDesc.Quality = 0;
    resourceDesc.Layout = D3D12_TEXTURE_LAYOUT_ROW_MAJOR;
    resourceDesc.Flags = D3D12_RESOURCE_FLAG_NONE;
    // Create the GPU upload buffer.
    // Note: using upload heaps to transfer static data like vert buffers is not 
    // recommended. Every time the GPU needs it, the upload heap will be marshalled 
    // over. Please read up on Default Heap usage. An upload heap is used here for 
    // code simplicity and because there are very few verts to actually transfer.
    if (FAILED(pDevice->CreateCommittedResource(
        &prop,
        D3D12_HEAP_FLAG_NONE,
        &resourceDesc,
        D3D12_RESOURCE_STATE_GENERIC_READ,
        nullptr,
        IID_PPV_ARGS(&m_pBuffer))))
    {
        return false;
    }

    // Copy the triangle data to the vertex buffer.
    UINT8* pVertexDataBegin;
    D3D12_RANGE readRange{}; // We do not intend to read from this resource on the CPU.
    m_pBuffer->Map(0, &readRange, reinterpret_cast<void**>(&pVertexDataBegin));
    memcpy(pVertexDataBegin, pVertices, size);
    m_pBuffer->Unmap(0, nullptr);

    // Initialize the vertex buffer view.
    m_VertexBufferView.BufferLocation = m_pBuffer->GetGPUVirtualAddress();
    m_VertexBufferView.StrideInBytes = 0;
    m_VertexBufferView.SizeInBytes = size;
    return true;
}

void VertexBuffer::Finalize(void)
{
}

IndexBuffer::IndexBuffer(void)
{}
IndexBuffer::~IndexBuffer(void)
{
	Finalize();
}
// CfbNXobt@̐
bool IndexBuffer::Create(UINT size, const UINT16* pIndeces)
{
	return false;
}


void IndexBuffer::Finalize(void)
{
}