#include "DirectXLib/DirectXLib.h"
#include <stdio.h>

#if false

Font::Font(void)
	: m_fontSize(0)
	, m_pFont(NULL)
{
}

Font::~Font(void)
{
	Finalize();
}

// tHg̐
bool Font::Initialize(int size)
{
	IDirect3DDevice9* pDevice = DirectXLib::Instance.GetDirect3DDevice();
	if( pDevice == NULL ) return false;

	D3DXFONT_DESCA desc;
	desc.Height				= size;
	desc.Width				= size / 2;
	desc.Weight				= 400;
	desc.MipLevels			= D3DX_DEFAULT;
	desc.Italic				= FALSE;
	desc.CharSet			= DEFAULT_CHARSET;
	desc.OutputPrecision	= OUT_DEFAULT_PRECIS;
	desc.Quality			= DEFAULT_QUALITY;
	desc.PitchAndFamily		= FIXED_PITCH | FF_MODERN;
	ZeroMemory(desc.FaceName, sizeof(desc.FaceName));

	D3DXCreateFontIndirectA(
		pDevice,
		&desc,
		&m_pFont
	);

	m_fontSize = size;
	return true;
}

// tHg̔j
void Font::Finalize(void)
{
	SAFE_RELEASE(m_pFont);
	m_fontSize = 0;
}

// tHg̍擾
int Font::GetHeight(void)
{
	return m_fontSize;
}

// bZ[W̕\
void Font::DrawText(int X, int Y, D3DCOLOR color, const char* pText)
{
	if( m_pFont == NULL ) return;

	RECT rect;
	SetRect(&rect, 0, 0, 0, 0);
	// `͈͂̎擾
	m_pFont->DrawTextA(NULL, pText, -1, &rect, DT_LEFT | DT_CALCRECT, color);

	// `
	OffsetRect(&rect, X, Y);
	m_pFont->DrawTextA(NULL, pText, -1, &rect, DT_LEFT, color);
}

// bZ[W̕\
void Font::DrawFormatText(int X, int Y, D3DCOLOR color, const char* pFormat, ...)
{
	char temp[MAX_PATH];

	va_list list;
	va_start(list, pFormat);
	vsprintf_s(temp, pFormat, list);
	va_end(list);

	DrawText(X, Y, color, temp);
}
#endif