#include "DirectXLib/DirectXLib.h"
#include "DirectX.h"

// DirectXNX
GraphicDescriptorHeap::GraphicDescriptorHeap(void)
{
}

GraphicDescriptorHeap::~GraphicDescriptorHeap(void)
{
}

bool GraphicDescriptorHeap::Initialize(DirectX12* pDirectX)
{
    auto& pDevice = pDirectX->GetDevice();

    // Describe and create a shader resource view (SRV) heap for the texture.
    D3D12_DESCRIPTOR_HEAP_DESC srvHeapDesc{};
    srvHeapDesc.NumDescriptors = 1;
    srvHeapDesc.Type = D3D12_DESCRIPTOR_HEAP_TYPE_CBV_SRV_UAV;
    srvHeapDesc.Flags = D3D12_DESCRIPTOR_HEAP_FLAG_SHADER_VISIBLE;
    if (FAILED(pDevice->CreateDescriptorHeap(&srvHeapDesc, IID_PPV_ARGS(&m_pHeap))))
    {
        return false;
    }
    m_DescriptorSize = pDevice->GetDescriptorHandleIncrementSize(D3D12_DESCRIPTOR_HEAP_TYPE_CBV_SRV_UAV);
    return true;
}

void GraphicDescriptorHeap::Finalize(void)
{
}

