#include "DirectXLib/DirectXLib.h"


Input::Input(void)
{
	Initialize();
}
Input::~Input(void)
{
	Finalize();
}

// ̓VXȅ
void Input::Initialize(void)
{
	for( int i=0; i < KeyBindMax; i++ )
	{
		m_keyState.keyBind[i] = -1;
	}
	m_keyState.keyState = 0;
	m_keyState.keyStateOld = 0;
}

// ̓VXẻ
void Input::Finalize(void)
{
	Initialize();
}

// ͏󋵂̍XV
void Input::Update(void)
{
	BYTE keyboardState[256];
	// L[{[hԂ̎擾
	GetKeyboardState(keyboardState);

	int keyState = 0;
	for( int i=0; i < KeyBindMax; i++ )
	{
		// L[oChĂȂ΃X[
		int key = m_keyState.keyBind[i];
		if( key == -1 ) continue;

		// ͂Ăꍇ̓L[̃rbg𗧂Ă
		if( keyboardState[key] & 0x80 )
		{
			keyState |= (1 << i);
		}
	}
	// Xe[g̍XV
	m_keyState.keyStateOld = m_keyState.keyState;
	m_keyState.keyState = keyState;
}

// L[oCh̐ݒ
void Input::BindKey(EKeyBind key, int keycode)
{
	m_keyState.keyBind[key] = keycode;
}

// L[Ă邩H
bool Input::IsKeyPress(EKeyBind key)
{
	int bit = (1 << key);
	int state = m_keyState.keyState;
	return (state & bit)? true: false;
}

// L[ꂽH
bool Input::IsKeyPush(EKeyBind key)
{
	int bit = (1 << key);
	int state = m_keyState.keyState & ~m_keyState.keyStateOld;
	return (state & bit)? true: false;
}

// L[ꂽH
bool Input::IsKeyReleases(EKeyBind key)
{
	int bit = (1 << key);
	int state = m_keyState.keyStateOld & ~m_keyState.keyState;
	return (state & bit)? true: false;
}
