#include "DirectXLib/DirectXLib.h"
#include <windows.h>


SceneManager::SceneManager(void)
	: m_pScene(NULL)
{}

SceneManager::~SceneManager(void)
{
	Finalize();
}

// V[Ǘ̏
void SceneManager::Initialize(void)
{
	m_pScene = NULL;
}

// V[Ǘ̉
void SceneManager::Finalize(void)
{
	// Ō͉ďI
	if( m_pScene ) m_pScene->Finalize();
	SAFE_DELETE(m_pScene);
}

// V[̍XV
void SceneManager::Update(void)
{
	if( m_pScene ) m_pScene->Update();
}

// V[̕`
void SceneManager::Render(void)
{
	if( m_pScene ) m_pScene->Render();

	//DEBUGFONT->DrawFormatText(0, 0, 0xffffffff, "Scene:%s", GetSceneName());
}

// V[̑J
bool SceneManager::JumpScene(SceneBase* pScene)
{
	// ݂̃V[
	if( m_pScene )
	{
		m_pScene->Finalize();
		SAFE_DELETE(m_pScene);
	}

	bool ret = true;
	// ̃V[Ώ
	if( pScene )
	{
		ret = pScene->Initialize();
	}
	m_pScene = pScene;
	return ret;
}

// V[̎擾
const char* SceneManager::GetSceneName(void)
{
	if( m_pScene ) return m_pScene->GetName();

	return "Unknown";
}