
#pragma once



// V[x[XNX
class SceneBase
{
public:
	// 
	virtual bool Initialize(void) = 0;
	// 
	virtual void Finalize(void) = 0;

	// XV
	virtual void Update(void) = 0;
	// `
	virtual void Render(void) = 0;

	// V[̎擾
	virtual const char* GetName(void) const = 0;
};

// V[Ǘ
class SceneManager
{
public:
	SceneManager(void);
	~SceneManager(void);

	// 
	void Initialize(void);
	// 
	void Finalize(void);
	// XV
	void Update(void);
	// `
	void Render(void);

	// V[̑J
	bool JumpScene(SceneBase* pScene);
	// V[̎擾
	const char* GetSceneName(void);

private:
	SceneBase*	m_pScene;
};