#include "DirectXLib/DirectXLib.h"
#define FBXSDK_SHARED
#include "FbxMeshAmg.h"


//****************************************************************
//
//	XV
//
//****************************************************************
//------------------------------------------------
//	XV
//------------------------------------------------
void FbxMeshAmg::Update()
{
	D3DXMATRIX mat;
	//D3DXMatrixIdentity(&mat);
	//	[hϊs(=p)
	D3DXMatrixRotationYawPitchRoll(
		&mat, 
		rotation.y,rotation.x, rotation.z
	);

	mat._11 *= scale.x;
	mat._12 *= scale.x;
	mat._13 *= scale.x;
	mat._21 *= scale.y;
	mat._22 *= scale.y;
	mat._23 *= scale.y;
	mat._31 *= scale.z;
	mat._32 *= scale.z;
	mat._33 *= scale.z;

	mat._41 = position.x;	// XW
	mat._42 = position.y;	// YW
	mat._43 = position.z;	// ZW

	//	sۑ
	transform = mat;
}

//------------------------------------------------
//	Aj[V
//------------------------------------------------
void FbxMeshAmg::Animate(float sec)
{
	float DeltaTime = sec;
	//	[VԂ̍XV
	Frame += DeltaTime * 60;
	//	[v`FbN
	if (Frame >= motion[MotionName].NumFrame - 1)
	{
		// [v
		Frame = 0;		// Ŝ[v
	}
}

//****************************************************************
//
//	`
//
//****************************************************************
//------------------------------------------------
//	`
//------------------------------------------------
void FbxMeshAmg::Render() {
	IDirect3DDevice9* device = GetDirect3DDevice();
	device->SetTransform(D3DTS_WORLD, &transform);

	//	[V݂ꍇSkinning
	if (motion[MotionName].NumFrame > 0) {
		Skinning();
	}

	//	device->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE );
	device->SetFVF(D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1 | D3DFVF_DIFFUSE);
	int start = 0;
	for (int m = 0; m<NumMesh; m++) {
		int material_no = MeshMaterial[m];
		device->SetMaterial(&material);
		if (Textures[material_no] != NULL) {
			device->SetTexture(0, Textures[material_no]);
		}
		//	`
		device->DrawIndexedPrimitiveUP(D3DPT_TRIANGLELIST, 0, NumVertices,
			MaterialFaces[m], &Indices[start], D3DFMT_INDEX32, Vertices, sizeof(PolygonVertex));
		start += MaterialFaces[m] * 3;
	}
}


//****************************************************************

//***********
// eNX`dǂݍ݋֎~
char TextureName[1000][128];
int  TextureCount[1000]; // QƃJE^
IDirect3DTexture9* TextureSource[1000];
bool IsInitializeTexture = false;

void InitTexture() {
	for (int i = 0; i < 1000; i++) {
		TextureName[i][0] = '\0';
		TextureSource[i] = NULL;
		TextureCount[i] = 0;
	}
	IsInitializeTexture = true;
}

IDirect3DTexture9* LoadTexture(char* filename)
{
	IDirect3DDevice9* device = GetDirect3DDevice();

	if (IsInitializeTexture == false) {
		InitTexture();
	}
	//	ɑ݂ꍇ
	for (int i = 0; i < 1000; i++) {
		if (TextureName[i][0] == '\0') continue;
		if (strcmp(TextureName[i], filename) == 0) {
			TextureCount[i]++;
			return TextureSource[i];
		}
	}

	//	󂫏ꏊɓǂݍ
	for (int i = 0; i < 1000; i++) {
		if (TextureName[i][0] != '\0') continue;

		IDirect3DTexture9* tex;
		if( SUCCEEDED(D3DXCreateTextureFromFileA(device, filename, &tex)) )
		{
			TextureSource[i] = tex;
			strcpy(TextureName[i], filename);
			TextureCount[i] = 1;
			return tex;
		}
		break;
	}
	return NULL;
}

void ReleaseTexture(IDirect3DTexture9* tex)
{
	//	
	for (int i = 0; i < 1000; i++) {
		if (TextureSource[i] != tex) continue;
		TextureCount[i]--;
		if (TextureCount[i] <= 0) {
			if (TextureSource[i] != NULL) {
				TextureSource[i]->Release();
				TextureSource[i] = NULL;
			}
			TextureName[i][0] = '\0';
		}
		return;
	}
	//	ǗÕeNX`
	if (tex != NULL) {
		tex->Release();
	}
}


//****************************************************************
//
//	
//
//****************************************************************
FbxMeshAmg::FbxMeshAmg()
{
	//	ގݒ
	//	ArGg()J[
	material.Ambient.r = 1.0f;
	material.Ambient.g = 1.0f;
	material.Ambient.b = 1.0f;
	material.Ambient.a = 1.0f;
	//	fBt[Y(fނ)J[
	material.Diffuse.r = 1.0f;
	material.Diffuse.g = 1.0f;
	material.Diffuse.b = 1.0f;
	material.Diffuse.a = 1.0f;
	//	XyL[ieJjJ[
	material.Specular.r = 1.0f;
	material.Specular.g = 1.0f;
	material.Specular.b = 1.0f;
	material.Specular.a = 1.0f;
	material.Power = 15.0f;
	//	G~bVuij
	material.Emissive.r = 0.0f;
	material.Emissive.g = 0.0f;
	material.Emissive.b = 0.0f;
	material.Emissive.a = 0.0f;
}

//****************************************************************
//
//	
//
//****************************************************************
FbxMeshAmg::~FbxMeshAmg()
{
	//	_
	delete[] Vertices;
	delete[] Indices;
	delete[] Weights;
	delete[] VerticesSrc;
	//	ގ֘A
	delete[] MaterialFaces;
	delete[] MeshMaterial;
	//	eNX`
	for( int i=0 ; i<NumMesh ; i++ ){
		if(Textures[i] != NULL )
//			Textures[i]->Release();
			ReleaseTexture(Textures[i]);

		if (NTextures[i] != NULL)
//			NTextures[i]->Release();
			ReleaseTexture(NTextures[i]);
	}
	delete[] Textures;
	delete[] NTextures;
	//	[V֘A
	for( auto i=motion.begin() ; i != motion.end() ; i++ ){
		Motion* M = &i->second;
		for( int bone=0 ; bone<NumBone ; bone++ ){
			delete[] M->key[bone];
		}
	}
	motion.clear();
}

//****************************************************************
//
//	t@Cǂݍ
//
//****************************************************************

void FbxMeshAmg::Create(const char* filename)
{
	//t@C菜
	strcpy(FBXDir, filename);
	for (int n = strlen(FBXDir) - 1; n >= 0; n--)
	{
		if (FBXDir[n] == '/' || FBXDir[n] == '\\')
		{
			FBXDir[n + 1] = '\0';
			break;
		}
	}

	if( strstr(filename, ".FBX") || strstr(filename, ".fbx") )
	{
		Load(filename);
	}
	else
	{
		LoadVertex(filename);
	}
	//	񏉊
	Frame = 0;
	position = D3DXVECTOR3(0, 0, 0);
	rotation = D3DXVECTOR3(0, 0, 0);
	scale = D3DXVECTOR3(1, 1, 1);
	Update();
}

void FbxMeshAmg::Load(const char* filename)
{
	FbxManager* manager = FbxManager::Create();
	FbxScene* scene = FbxScene::Create(manager, "");
	//	t@CV[ɓǂݍ
	FbxImporter* importer = FbxImporter::Create(manager, "");
	importer->Initialize(filename);
	importer->Import(scene);
	importer->Destroy();

	//	[V擾
	FbxArray<FbxString*> names;
	scene->FillAnimStackNameArray(names);

	if (names != NULL) {
		//	[V݂Ƃ
		FbxTakeInfo* take = scene->GetTakeInfo(names[0]->Buffer());
		FbxLongLong start = take->mLocalTimeSpan.GetStart().Get();
		FbxLongLong stop = take->mLocalTimeSpan.GetStop().Get();
		FbxLongLong fps60 = FbxTime::GetOneFrameValue(FbxTime::eFrames60);
		StartFrame = (int)(start / fps60);
		motion["default"].NumFrame = (int)((stop - start) / fps60);
	}
	else {
		StartFrame = 0;
		motion["default"].NumFrame = 0;
	}

	//	fގƂɕ
	FbxGeometryConverter fgc(manager);
	fgc.SplitMeshesPerMaterial(scene, true);
	fgc.Triangulate(scene, true);
	NumBone = 0;

	//	bV
	NumMesh = scene->GetSrcObjectCount<FbxMesh>();

	//	_vZ
	int work = 0;
	for (int m = 0; m < NumMesh; m++) {
		FbxMesh* mesh = scene->GetSrcObject<FbxMesh>(m);
		int num = mesh->GetPolygonVertexCount();
		work += num; // v_
	}

	//	_m
	Vertices = new PolygonVertex[work];
	Indices = new DWORD[work];
	Weights = new WEIGHT[work];

	NumVertices = 0;
	//	
	for (int v = 0; v < work; v++) {
		Weights[v].count = 0;
	}

	//ގƂ̃|S_
	MaterialFaces = new int[NumMesh];
	MeshMaterial = new int[NumMesh];

	Textures = new IDirect3DTexture9*[NumMesh];
	NTextures = new IDirect3DTexture9*[NumMesh];
	for (int m = 0; m < NumMesh; m++)
	{
		Textures[m] = NULL;
		NTextures[m] = NULL;
	}

	//	_ǂݍ
	for (int m = 0; m < NumMesh; m++) {
		FbxMesh* mesh = scene->GetSrcObject<FbxMesh>(m);
		int num = mesh->GetPolygonVertexCount();

		//	_ǂݍ
		LoadPosition(mesh);		//	Wǂݍ
		LoadNormal(mesh);		//	@ǂݍ
		LoadUV(mesh);			//	eNX`UV
		LoadVertexColor(mesh);	//	_J[ǂݍ

								//	CfbNXݒ(Op`)
		for (int i = 0; i < num; i += 3) {
			Indices[i + 0 + NumVertices] = i + 2 + NumVertices;
			Indices[i + 1 + NumVertices] = i + 1 + NumVertices;
			Indices[i + 2 + NumVertices] = i + 0 + NumVertices;
		}

		//	{[ǂݍ
		LoadBone(mesh);


		//	gpގݒ
		//	bV̎gpގ擾
		FbxLayerElementMaterial* LEM = mesh->GetElementMaterial();
		if (LEM != NULL) {
			//	|Sɓ\Ăގԍ
			int material_index = LEM->GetIndexArray().GetAt(0);
			//	bVގmaterial_indexԖڂ擾
			FbxSurfaceMaterial* material = mesh->GetNode()->GetSrcObject<FbxSurfaceMaterial>(material_index);
			LoadMaterial(m, material);
		}
		MeshMaterial[m] = m;
		MaterialFaces[m] = num / 3;

		NumVertices += num;
	}

	NumFaces = NumVertices / 3;
	OptimizeVertices();

	//	_f[^ۑ
	VerticesSrc = new PolygonVertex[NumVertices];
	memcpy(VerticesSrc, Vertices, sizeof(PolygonVertex)*NumVertices);

	//	EFCgK
	// T{ȏɂ܂Ăꍇ̂
	for (int v = 0; v < NumVertices; v++) {
		float n = 0;
		//	_̃EFCg̍vl
		for (int w = 0; w < Weights[v].count; w++) {
			n += Weights[v].weight[w];
		}
		//	K
		for (int w = 0; w < Weights[v].count; w++) {
			Weights[v].weight[w] /= n;
		}
	}

	//	
	scene->Destroy();
	manager->Destroy();

	Play("default");
}

//****************************************************************
//
//	_ǂݍ
//
//****************************************************************
//------------------------------------------------
//	Wǂݍ
//------------------------------------------------
void FbxMeshAmg::LoadPosition(FbxMesh* mesh) {
	int* index = mesh->GetPolygonVertices();
	FbxVector4* source = mesh->GetControlPoints();
	// bṼgXtH[
	FbxVector4 T = mesh->GetNode()->GetGeometricTranslation(FbxNode::eSourcePivot);
	FbxVector4 R = mesh->GetNode()->GetGeometricRotation(FbxNode::eSourcePivot);
	FbxVector4 S = mesh->GetNode()->GetGeometricScaling(FbxNode::eSourcePivot);
	FbxAMatrix TRS = FbxAMatrix(T, R, S);
	//	S_ϊ
	for (int v = 0; v < mesh->GetControlPointsCount(); v++) {
		source[v] = TRS.MultT(source[v]);
	}

	// _Wǂݍ
	int num = mesh->GetPolygonVertexCount();
	for (int v = 0; v < num; v++) {
		int vindex = index[v];

		Vertices[v + NumVertices].x = (float)-source[vindex][0];
		Vertices[v + NumVertices].y = (float)source[vindex][1];
		Vertices[v + NumVertices].z = (float)source[vindex][2];

		Vertices[v + NumVertices].tu = 0;
		Vertices[v + NumVertices].tv = 0;
		Vertices[v + NumVertices].color = 0xFFFFFFFF;
	}
}

//------------------------------------------------
//	@ǂݍ
//------------------------------------------------
void FbxMeshAmg::LoadNormal(FbxMesh* mesh) {
	FbxArray<FbxVector4> normal;
	mesh->GetPolygonVertexNormals(normal);
	for (int v = 0; v < normal.Size(); v++)
	{
		Vertices[v + NumVertices].nx = -(float)normal[v][0];
		Vertices[v + NumVertices].ny = (float)normal[v][1];
		Vertices[v + NumVertices].nz = (float)normal[v][2];
	}
}

//------------------------------------------------
//	tuǂݍ
//------------------------------------------------
void FbxMeshAmg::LoadUV(FbxMesh* mesh) {
	FbxStringList names;
	mesh->GetUVSetNames(names);
	FbxArray<FbxVector2> uv;
	mesh->GetPolygonVertexUVs(names.GetStringAt(0), uv);
	for (int v = 0; v < uv.Size(); v++) {
		Vertices[v + NumVertices].tu = (float)(uv[v][0]);
		Vertices[v + NumVertices].tv = (float)(1.0 - uv[v][1]);
	}
}

//------------------------------------------------
//	_J[ǂݍ
//------------------------------------------------
void FbxMeshAmg::LoadVertexColor(FbxMesh* mesh) {

	int vColorLayerCount = mesh->GetElementVertexColorCount();
	if (mesh->GetElementVertexColorCount() <= 0) return;
	//    _J[C[擾
	FbxGeometryElementVertexColor* element = mesh->GetElementVertexColor(0);

	//  ۑ`̎擾
	FbxGeometryElement::EMappingMode mapmode = element->GetMappingMode();
	FbxGeometryElement::EReferenceMode refmode = element->GetReferenceMode();

	//    |S_ɑ΂CfbNXQƌ`̂ݑΉ
	if (mapmode == FbxGeometryElement::eByPolygonVertex)
	{
		if (refmode == FbxGeometryElement::eIndexToDirect)
		{
			FbxLayerElementArrayTemplate<int>* index = &element->GetIndexArray();
			int indexCount = index->GetCount();
			for (int j = 0; j<indexCount ; j++) {
				// FbxColor擾
				FbxColor c = element->GetDirectArray().GetAt(index->GetAt(j));
				// DWORD^̃J[쐬        
				DWORD color = ((DWORD)(c.mAlpha * 255)<<24) + ((DWORD)(c.mRed * 255)<<16) + ((DWORD)(c.mGreen * 255)<<8) + ((DWORD)(c.mBlue * 255));
				Vertices[j + NumVertices].color = color;
			}
		}
	}
}

//****************************************************************
//	ގǂݍ
//****************************************************************
void FbxMeshAmg::LoadMaterial(int index, FbxSurfaceMaterial * material)
{
	IDirect3DDevice9* device = GetDirect3DDevice();
	FbxProperty prop = material->FindProperty(FbxSurfaceMaterial::sDiffuse);

	//	eNX`ǂݍ
	const char* path = NULL;
	int fileTextureCount = prop.GetSrcObjectCount<FbxFileTexture>();
	if (fileTextureCount > 0) {
		FbxFileTexture* FileTex = prop.GetSrcObject<FbxFileTexture>(0);
		path = FileTex->GetFileName();
	} else {
		int numLayer = prop.GetSrcObjectCount<FbxLayeredTexture>();
		if (numLayer > 0) {
			FbxLayeredTexture* LayerTex = prop.GetSrcObject<FbxLayeredTexture>(0);
			FbxFileTexture* FileTex = LayerTex->GetSrcObject<FbxFileTexture>(0);
			path = FileTex->GetFileName();
		}
	}
	if( path == NULL ) return;

	//  C:\\AAA\\BBB\\a.fbx  C:/AAA/BBB/a.fbx
	const char* name = &path[strlen(path)];
	for (int i = 0; i < (int)strlen(path); i++)
	{
		name--;
		if (name[0] == '/'){name++; break; }
		if (name[0] == '\\') { name++; break; }
	}
	char* ext = (char*)strstr(name, ".psd");
	if( ext )
	{
		strcpy(ext, ".tga");
	}

	char work[128];
	strcpy(work, FBXDir);		//"AAA/BBB/";
	strcat(work, "texture/");	//"AAA/BBB/texture/"
	strcat(work, name);			//"AAA/BBB/texture/a.png

	char filename[128];
	strcpy(filename, work);
	//D3DXCreateTextureFromFile(device, filename, &Textures[index] );
	Textures[index] = LoadTexture(filename);

	//	@}bvǂݍ
	strcpy(work, FBXDir);		//"AAA/BBB/";
	strcat(work, "texture/N");	//"AAA/BBB/texture/N"
	strcat(work, name);			//"AAA/BBB/texture/Na.png
	strcpy(filename, work);
	//D3DXCreateTextureFromFile(device, filename, &NTextures[index]);
	NTextures[index] = LoadTexture(filename);

}

//****************************************************************
//	{[
//****************************************************************
int FbxMeshAmg::FindBone(const char* name)
{
	int bone = -1; // Ȃ
	for( int i=0 ; i<NumBone ; i++ ){
		if( strcmp( name,Bone[i].Name) == 0 ){
			bone = i;
			break;
		}	
	}
	return bone;
}

void FbxMeshAmg::LoadBone(FbxMesh* mesh)
{
	//	bV_
	int num = mesh->GetPolygonVertexCount();

	//	XL̗L
	int skinCount = mesh->GetDeformerCount(FbxDeformer::eSkin );
	if( skinCount <= 0 ){
		LoadMeshAnim(mesh);
		return;
	}
	FbxSkin* skin = static_cast<FbxSkin*>(mesh->GetDeformer( 0, FbxDeformer::eSkin) );
	//	{[
	int nBone = skin->GetClusterCount();
	//	S{[擾
	for( int bone=0 ; bone<nBone ; bone++ )
	{
		//	{[擾
		FbxCluster* cluster = skin->GetCluster(bone);
		FbxAMatrix trans;
		cluster->GetTransformMatrix(trans);
		trans.mData[0][1] *= -1;
		trans.mData[0][2] *= -1;
		trans.mData[1][0] *= -1;
		trans.mData[2][0] *= -1;
		trans.mData[3][0] *= -1;
		
		//	{[擾
		const char* name = cluster->GetLink()->GetName();

		//	{[
		bool isNewBone = false;
		int bone_no = FindBone(name);
		if( bone_no < 0 ){
			bone_no = NumBone;
			NumBone++;
			isNewBone = true;
		}
		if( isNewBone ){
			strcpy(Bone[bone_no].Name, name );
			//	ItZbgs쐬
			FbxAMatrix LinkMatrix;
			cluster->GetTransformLinkMatrix(LinkMatrix);
			LinkMatrix.mData[0][1] *= -1;
			LinkMatrix.mData[0][2] *= -1;
			LinkMatrix.mData[1][0] *= -1;
			LinkMatrix.mData[2][0] *= -1;
			LinkMatrix.mData[3][0] *= -1;

			FbxAMatrix Offset = LinkMatrix.Inverse() * trans;
			FbxDouble* OffsetM = (FbxDouble*)Offset;

			//	ItZbgsۑ
			for( int i=0 ; i<16 ; i++ ){
				Bone[bone_no].OffsetMatrix.m[i/4][i%4] = (float)OffsetM[i];
			}

			//	L[t[ǂݍ
			LoadKeyFrames("default", bone_no, cluster->GetLink());
		}

		//	EFCgǂݍ
		int wgtcount = cluster->GetControlPointIndicesCount();
		int* wgtindex = cluster->GetControlPointIndices();
		double* wgt = cluster->GetControlPointWeights();
		
		int* index = mesh->GetPolygonVertices();

		for( int i=0 ; i<wgtcount ; i++ ){
			int wgtindex2 = wgtindex[i];
			//	S|Swgtindex2Ԗڂ̒_
			for( int v=0 ; v<num ; v++ ){
				if( index[v] != wgtindex2 ) continue;
				//	_ɃEFCgۑ
				int w = Weights[v + NumVertices].count;
				if( w >= 4 ){
					continue;
				}
				Weights[v+NumVertices].bone[w] = bone_no;
				Weights[v+NumVertices].weight[w] = (float)wgt[i];
				Weights[v+NumVertices].count ++;
			}
		}
	}
}

//	{[̂ȂbṼAj[V
void FbxMeshAmg::LoadMeshAnim(FbxMesh* mesh)
{
	FbxNode* node = mesh->GetNode();

	int bone_no = NumBone;
	strcpy( Bone[bone_no].Name, node->GetName());

	//	ItZbgsi_Ɉړsj
	D3DXMatrixIdentity(
		&Bone[bone_no].OffsetMatrix
	);

	//	L[t[ǂݍ
	LoadKeyFrames( "default", bone_no, node);

	//	EFCgݒ
	int num = mesh->GetPolygonVertexCount();
	for( int i=0 ; i<num ; i++ ){
		Weights[i+NumVertices].bone[0] = bone_no;
		Weights[i+NumVertices].weight[0] = 1.0f;
		Weights[i+NumVertices].count = 1;
	}

	NumBone++;
}

//	L[t[ǂݍ
void FbxMeshAmg::LoadKeyFrames( std::string name, int bone, FbxNode* bone_node){
	//	m
	Motion* M = &motion[name];
	M->key[bone] =
	 new D3DXMATRIX[M->NumFrame+1];

	double time = StartFrame*(1.0 / 60);
	FbxTime T;
	for (int f = 0; f<motion[name].NumFrame; f++) {
		T.SetSecondDouble(time);
		//	Tb̎psGet
		FbxMatrix m = bone_node->EvaluateGlobalTransform(T);
		m.mData[0][1] *= -1;// _12
		m.mData[0][2] *= -1;// _13
		m.mData[1][0] *= -1;// _21
		m.mData[2][0] *= -1;// _31
		m.mData[3][0] *= -1;// _41

		FbxDouble* mat = (FbxDouble*)m;
		for (int i = 0; i<16; i++) {
			motion[name].key[bone][f].m[i / 4][i % 4] = (float)mat[i];
		}

		time += 1.0 / 60.0;
	}
}


//	{[s̕
void MatrixInterporate( D3DXMATRIX& out, D3DXMATRIX& A, D3DXMATRIX B, float rate )
{
	out = A * (1.0f - rate) + B * rate;
}

void FbxMeshAmg::Skinning()
{
//	int motion_no = MotionNo;
	Motion* M = &motion[MotionName];
	if( M == NULL ) return;

	//	zpϐ
	int f = (int)Frame;
	//	s񏀔
	D3DXMATRIX KeyMatrix[256];
	for( int b=0 ; b<NumBone ; b++ )
	{
		if( !M->key[b] ) continue;
		//	s
		D3DXMATRIX m;
		MatrixInterporate( m, M->key[b][f], M->key[b][f+1], Frame - (int)Frame );
		Bone[b].transform = m;
		//	L[t[
		KeyMatrix[b] = Bone[b].OffsetMatrix * m;
	}

	//	_ό`
	for( int v=0 ; v<NumVertices ; v++ )
	{
		//	_ * {[s
		// b = vԖڂ̒_̉e{[[n]
		if (Weights[v].count <= 0) continue;

		Vertices[v].x = 0;
		Vertices[v].y = 0;
		Vertices[v].z = 0;

		//	e[v
		for( int n=0 ; n<Weights[v].count ; n++ ){
			int b = Weights[v].bone[n];

			float x = VerticesSrc[v].x;
			float y = VerticesSrc[v].y;
			float z = VerticesSrc[v].z;
			//	We͕ړ
			Vertices[v].x += (x*KeyMatrix[b]._11 + y*KeyMatrix[b]._21 + z*KeyMatrix[b]._31 + 1*KeyMatrix[b]._41 )*Weights[v].weight[n];
			Vertices[v].y += (x*KeyMatrix[b]._12 + y*KeyMatrix[b]._22 + z*KeyMatrix[b]._32 + 1*KeyMatrix[b]._42 )*Weights[v].weight[n];
			Vertices[v].z += (x*KeyMatrix[b]._13 + y*KeyMatrix[b]._23 + z*KeyMatrix[b]._33 + 1*KeyMatrix[b]._43 )*Weights[v].weight[n];

			float nx = VerticesSrc[v].nx;
			float ny = VerticesSrc[v].ny;
			float nz = VerticesSrc[v].nz;
			//	@e͕ϊ
			Vertices[v].nx += (nx*KeyMatrix[b]._11 + ny*KeyMatrix[b]._21 + nz*KeyMatrix[b]._31)*Weights[v].weight[n];
			Vertices[v].ny += (nx*KeyMatrix[b]._12 + ny*KeyMatrix[b]._22 + nz*KeyMatrix[b]._32)*Weights[v].weight[n];
			Vertices[v].nz += (nx*KeyMatrix[b]._13 + ny*KeyMatrix[b]._23 + nz*KeyMatrix[b]._33)*Weights[v].weight[n];

		}
	}
}

void FbxMeshAmg::AddMotion(std::string name, const char * filename)
{
	FbxManager* manager = FbxManager::Create();
	FbxScene* scene = FbxScene::Create(manager, "");

	//	t@CV[ɓǂݍ
	FbxImporter* importer = FbxImporter::Create(manager, "");
	importer->Initialize(filename);
	importer->Import(scene);
	importer->Destroy();

	//	[V擾
	FbxArray<FbxString*> names;
	scene->FillAnimStackNameArray(names);

	FbxTakeInfo* take = scene->GetTakeInfo(names[0]->Buffer());
	FbxLongLong start = take->mLocalTimeSpan.GetStart().Get();
	FbxLongLong stop = take->mLocalTimeSpan.GetStop().Get();
	FbxLongLong fps60 = FbxTime::GetOneFrameValue(FbxTime::eFrames60);

	StartFrame = (int)(start / fps60);
	motion[name].NumFrame = (int)((stop - start) / fps60);
	//	[gm[h擾
	FbxNode* root = scene->GetRootNode();

	//	S{[ǂݍ
	for( int b=0 ; b<NumBone ; b++ ){
		//	{[m[h
		FbxNode* bone = root->FindChild( Bone[b].Name );
		if( bone == NULL ) continue;
		//	L[t[ǂݍ
		LoadKeyFrames(name, b, bone);
	}
	//	
	scene->Destroy();
	manager->Destroy();
}

//****************************************************************
//	_œK
//****************************************************************
void FbxMeshAmg::OptimizeVertices()
{
	int currentNum = 0;
	for (int v = 0; v < NumVertices; v++) {
		int sameIndex = -1;
		//	꒸_
		for (int old = 0; old < currentNum; old++) {
			if (Vertices[v].x != Vertices[old].x) continue;
			if (Vertices[v].y != Vertices[old].y) continue;
			if (Vertices[v].z != Vertices[old].z) continue;
			if (Vertices[v].nx != Vertices[old].nx) continue;
			if (Vertices[v].ny != Vertices[old].ny) continue;
			if (Vertices[v].nz != Vertices[old].nz) continue;
			if (Vertices[v].tu != Vertices[old].tu) continue;
			if (Vertices[v].tv != Vertices[old].tv) continue;
			if (Vertices[v].color != Vertices[old].color) continue;

			sameIndex = old;
			break;
		}

		int target = v;
		if (sameIndex == -1) {
			//	VK_
			CopyMemory(&Vertices[currentNum], &Vertices[v], sizeof(PolygonVertex));
			CopyMemory(&Weights[currentNum], &Weights[v], sizeof(WEIGHT));
			target = currentNum;
			currentNum++;
		}
		else {
			target = sameIndex;
		}
		//	CfbNXXV
		for (int i = 0; i < NumVertices; i++) {
			if(Indices[i] == v ) Indices[i] = target;
		}
	}

	//	Vobt@m
	PolygonVertex* buf = new PolygonVertex[currentNum];
	CopyMemory(buf, Vertices, sizeof(PolygonVertex) * currentNum);
	NumVertices = currentNum;

	delete[] Vertices;
	Vertices = buf;
}

bool FbxMeshAmg::LoadVertex(const char* path)
{
	FILE* file = fopen(path, "rb");
	if( file == NULL ) return false;

	int MotionNum;
	fread(&NumMesh, sizeof(NumMesh), 1, file);
	fread(&NumVertices, sizeof(NumVertices), 1, file);
	fread(&NumFaces, sizeof(NumFaces), 1, file);
	fread(&NumBone, sizeof(NumBone), 1, file);
	fread(&MotionNum, sizeof(MotionNum), 1, file);

	MaterialFaces = new int[NumMesh];
	MeshMaterial = new int[NumMesh];
	Vertices = new PolygonVertex[NumVertices];
	Indices = new DWORD[NumFaces * 3];
	Weights = new WEIGHT[NumVertices];

	fread(MaterialFaces, sizeof(int), NumMesh, file);
	fread(MeshMaterial, sizeof(int), NumMesh, file);
	fread(Vertices, sizeof(PolygonVertex), NumVertices, file);
	fread(Indices, sizeof(DWORD), NumFaces * 3, file);
	fread(Weights, sizeof(WEIGHT), NumVertices, file);
	fread(Bone, sizeof(BONE), NumBone, file);

	//	_f[^ۑ
	VerticesSrc = new PolygonVertex[NumVertices];
	memcpy(VerticesSrc, Vertices, sizeof(PolygonVertex)*NumVertices);

	Textures = new IDirect3DTexture9*[NumMesh];
	NTextures = new IDirect3DTexture9*[NumMesh];
	for( int m=0; m < NumMesh; m++ )
	{
		char temp[256];
		fread(temp, sizeof(char), 256, file);

		if( temp[m] == '\0' )
		{
			Textures[m] = NTextures[m] = NULL;
			continue;
		}
		char work[128];
		strcpy(work, FBXDir);		//"AAA/BBB/";
		strcat(work, "texture/");	//"AAA/BBB/texture/"
		strcat(work, temp);			//"AAA/BBB/texture/a.png

		char filename[128];
		strcpy(filename, work);
		Textures[m] = LoadTexture(filename);

		//	@}bvǂݍ
		strcpy(work, FBXDir);		//"AAA/BBB/";
		strcat(work, "texture/N");	//"AAA/BBB/texture/N"
		strcat(work, temp);			//"AAA/BBB/texture/Na.png
		strcpy(filename, work);
		NTextures[m] = LoadTexture(filename);
	}

	for( int i=0; i < MotionNum; i++ )
	{
		char temp[256];
		fread(temp, sizeof(char), 256, file);

		Motion M;
		fread(&M.NumFrame, sizeof(int), 1, file);
		for( int j=0; j < NumBone; j++ )
		{
			M.key[j] = new D3DXMATRIX[M.NumFrame];
			fread(M.key[j], sizeof(D3DXMATRIX), M.NumFrame, file);
		}
		motion[temp] = M;
	}
	fclose(file);

	Play("default");

	return true;
}

//!	bVt@C̏o
void FbxMeshAmg::SaveMesh(const char* path)
{
	FILE* file = fopen(path, "wb");

	int MotionNum = motion.size();
	fwrite(&NumMesh, sizeof(NumMesh), 1, file);
	fwrite(&NumVertices, sizeof(NumVertices), 1, file);
	fwrite(&NumFaces, sizeof(NumFaces), 1, file);
	fwrite(&NumBone, sizeof(NumBone), 1, file);
	fwrite(&MotionNum, sizeof(MotionNum), 1, file);

	fwrite(MaterialFaces, sizeof(int), NumMesh, file);
	fwrite(MeshMaterial, sizeof(int), NumMesh, file);
	fwrite(Vertices, sizeof(PolygonVertex), NumVertices, file);
	fwrite(Indices, sizeof(DWORD), NumFaces * 3, file);
	fwrite(Weights, sizeof(WEIGHT), NumVertices, file);
	fwrite(Bone, sizeof(BONE), NumBone, file);

	for( int m=0; m < NumMesh; m++ )
	{
		if( Textures[m] == NULL )
		{
			char temp[256] = {};
			fwrite(temp, sizeof(char), 256, file);
			continue;
		}
		for( int i = 0; i < 1000; i++ )
		{
			if( TextureSource[i] != Textures[m] ) continue;

			char* pName = TextureName[i];
			int j;
			for( j=strlen(pName); 0 < j; j-- )
			{
				if( pName[j] == '/' )
				{
					j ++;
					break;
				}
			}
			char temp[256];
			strcpy(temp, &pName[j]);
			fwrite(temp, sizeof(char), 256, file);
			break;
		}
	}

	std::map<std::string, Motion>::iterator it = motion.begin();
	for( ; it != motion.end(); ++it )
	{
		char temp[256];
		strcpy(temp, it->first.c_str());
		fwrite(temp, sizeof(char), 256, file);
		fwrite(&it->second.NumFrame, sizeof(int), 1, file);
		for( int j=0; j < NumBone; j++ )
		{
			fwrite(it->second.key[j], sizeof(D3DXMATRIX), it->second.NumFrame, file);
		}
	}

	fclose(file);
}