#pragma once
#include <d3d9.h>
#include <d3dx9.h>
#include <map>	//	STL(֎~̉ЂBBB)

#include <fbxsdk.h>

class FbxMeshAmg
{
protected:
	//	ŒVF[_[pގ
	D3DMATERIAL9 material;

	//	_\́iVF[_[ƈvj
	struct PolygonVertex {
		float x, y, z;		// W
		float nx, ny, nz;	// @
		DWORD color;		// _J[
		float tu, tv;		// UV
	};


	bool UseVertexData;

	int NumMesh;
	int NumVertices;	//S_
	int NumFaces;		//S|S
	PolygonVertex* Vertices;	//_
	PolygonVertex* VerticesSrc; //_f[^
	DWORD* Indices;		//Op`i_ѕj

	char FBXDir[128];
	int* MeshMaterial;
	int* MaterialFaces;
	IDirect3DTexture9** Textures;
	IDirect3DTexture9** NTextures;

	//	{[֘A
	struct BONE {
		char	Name[128];
		D3DXMATRIX	OffsetMatrix;
		D3DXMATRIX	transform;
	};
	int NumBone;
	BONE Bone[256];

	int FindBone( const char* name );
	void LoadBone( FbxMesh* mesh );
	void LoadMeshAnim(FbxMesh* mesh);
	
	//	EFCg֘A
	struct WEIGHT {
		int count;
		int bone[4];
		float weight[4];
	};
	WEIGHT* Weights;

	int StartFrame;
	void Skinning();	// {[ɂό`

	static const int MOTION_MAX = 256; 
	static const int BONE_MAX = 256; 

	//	Aj[V
	struct Motion {
		int NumFrame;	// t[	
		//D3DXMATRIX key[BONE_MAX][120];	// L[t[
		D3DXMATRIX* key[BONE_MAX];	// L[t[
	};
	// int MotionNo;

	int NumMotion;		// [V
	std::map<std::string, Motion> motion;	// [Vf[^
	void LoadKeyFrames(std::string name, int bone, FbxNode* bone_node);

	void Load(const char* filename);
	void LoadMaterial( int index, FbxSurfaceMaterial* material );

	void LoadPosition(FbxMesh* mesh);
	void LoadNormal(FbxMesh* mesh);
	void LoadUV(FbxMesh* mesh);
	void LoadVertexColor(FbxMesh* mesh);

	void OptimizeVertices();


	bool LoadVertex(const char* path);

public:
	//!	bVt@C̏o
	void SaveMesh(const char* path);

public:
	FbxMeshAmg();
	virtual ~FbxMeshAmg();

	void Update();

	void Render();	//	`

	void Play(std::string name) {
		MotionName = name;
		Frame = 0.0f;
	}
	void Animate(float sec);	// [VĐ

	void Create(const char* filename);
	void AddMotion( std::string name, const char* filename);

	//	[V
	float Frame;		// ݂̃t[
	std::string MotionName;		// ݂̃[V

	//	p
	D3DXMATRIX transform;
	D3DXVECTOR3 position;
	D3DXVECTOR3 rotation;
	D3DXVECTOR3 scale;
	//	{[s擾
	D3DXMATRIX GetBoneMatrix( int bone ){ return Bone[bone].transform; }

};

