#include "DirectXLib/DirectXLib.h"
#include "3DTestScene.h"
#include "SystemScene.h"


Test3DScene::Test3DScene(void)
{
}
Test3DScene::~Test3DScene(void)
{
}


// 
bool Test3DScene::Initialize(void)
{
	// assetstH_bridge.pngeNX`[Ƃēǂݍ
	if( !m_texture.Load("assets/bridge.png") )
	{
		return false;
	}
	float aspect = (float)m_texture.GetSrcWidth() / (float)m_texture.GetSrcHeight();
	// 摜TCY畝ƍݒ
	float rect[] =
	{
		-0.5f * aspect,  0.5f,
		 0.5f * aspect, -0.5f,
	};
	// eNX`[TCY摜TCYUV擾(摜2̗ݏł1.0fɂȂ)
	float u = (float)m_texture.GetSrcWidth() / (float)m_texture.GetWidth();
	float v = (float)m_texture.GetSrcHeight() / (float)m_texture.GetHeight();
	// 摜TCYɍ킹UVǉ_f[^
	const SimpleTexVertex vertices[4] =
	{
		// 1ڂ̋`
		{ rect[0], rect[1], 0.0f, 0xffffffff, 0.0f, 0.0f },
		{ rect[2], rect[1], 0.0f, 0xffffffff,    u, 0.0f },
		{ rect[0], rect[3], 0.0f, 0xffffffff, 0.0f,    v },
		{ rect[2], rect[3], 0.0f, 0xffffffff,    u,    v },
	};
	// _obt@̐
	if( !m_vertexBuffer.Create(sizeof(vertices), vertices) )
	{
		return false;
	}

	return true;
}

// 
void Test3DScene::Finalize(void)
{
	m_texture.Finalize();
	m_vertexBuffer.Finalize();
}

static float angle = 0.0f;
// XV
void Test3DScene::Update(void)
{
	D3DXMatrixPerspectiveFovLH(
		&m_projectionMatrix,
		D3DXToRadian(45.0f),
		640.0f / 480.0f,
		0.01f,
		1000.0f
	);

	D3DXVECTOR3 cameraPos(0.0f, 0.5f, -3.0f);
	D3DXVECTOR3 targetPos(0.0f, 0.0f, 0.0f);
	D3DXVECTOR3 upVec(0.0f, 1.0f, 0.0f);
	D3DXMatrixLookAtLH(&m_viewMatrix, &cameraPos, &targetPos, &upVec);

	if( INPUT->IsKeyPress(Input::Left) )
	{
		angle += D3DXToRadian(1.0f);
	}
	else if( INPUT->IsKeyPress(Input::Right) )
	{
		angle -= D3DXToRadian(1.0f);
	}
	D3DXMatrixRotationY(&m_worldMatrix, angle);

	if( INPUT->IsKeyPush(Input::A) )
	{
		SCENEMANAGER->JumpScene(new SystemScene);
	}
}

// `
void Test3DScene::Render(void)
{
	IDirect3DDevice9* pDevice = DirectXLib::Instance.GetDirect3DDevice();
	DirectX* pDirectX = DirectXLib::Instance.GetDirectX();

	// View, Projections̐ݒ
	pDevice->SetTransform(D3DTS_VIEW, &m_viewMatrix);
	pDevice->SetTransform(D3DTS_PROJECTION, &m_projectionMatrix);

	// ʏ폑݃[hɐݒ
	pDirectX->SetRenderMode(DirectX::Normal, false);

	pDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE);
	pDevice->SetRenderState(D3DRS_LIGHTING, FALSE);
	// Worlds̐ݒ
	pDevice->SetTransform(D3DTS_WORLD, &m_worldMatrix);
	// eNX`[̐ݒ
	pDevice->SetTexture(0, m_texture.GetD3DTexture());
	// _obt@̐ݒ
	pDevice->SetStreamSource(0, m_vertexBuffer.GetBuffer(), 0, sizeof(SimpleTexVertex));

	// _tH[}bg̎w
	pDevice->SetFVF(FVF_SIMPLE_TEX_3D);
	// `
	pDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);


	DEBUGFONT->DrawFormatText(0, 64, 0xffffffff, "Angle:%f", angle);
}
