#include "DirectXLib/DirectXLib.h"
#include "SystemScene.h"
#include "TextureTestScene.h"
#include "SpriteTestScene.h"



SystemScene::SystemScene(void)
{
#if defined(_DEBUG)
	m_selectScene = 0;

	SceneBase* pSceneList[] =
	{
		new SpriteTestScene,
		new TextureTestScene,
	};

	m_sceneNum = ARRAYSIZE(pSceneList);
	m_ppSceneList = new SceneBase*[ARRAYSIZE(pSceneList)];
	for( int i=0; i < m_sceneNum; i++ )
	{
		m_ppSceneList[i] = pSceneList[i];
	}
#endif
}
SystemScene::~SystemScene(void)
{
#if defined(_DEBUG)
	m_selectScene = 0;
	for( int i=0; i < m_sceneNum; i++ )
	{
		SAFE_DELETE(m_ppSceneList[i]);
	}
	SAFE_DELETE(m_ppSceneList);
#endif
}


// 
bool SystemScene::Initialize(void)
{
	// L[oCh̐ݒ
	INPUT->BindKey(Input::Option,	VK_SPACE);
	INPUT->BindKey(Input::A,		VK_RETURN);
	INPUT->BindKey(Input::B,		VK_BACK);
	INPUT->BindKey(Input::Up,		VK_UP);
	INPUT->BindKey(Input::Down,		VK_DOWN);
	INPUT->BindKey(Input::Left,		VK_LEFT);
	INPUT->BindKey(Input::Right,	VK_RIGHT);

#if defined(_DEBUG)
	m_selectScene = 0;
#else
	JumpScene(new TextureTestScene);
#endif

	return true;
}

// 
void SystemScene::Finalize(void)
{
#if defined(_DEBUG)
	// IV[͍폜Ȃ悤ɏO
	m_ppSceneList[m_selectScene] = NULL;
#endif
}

// XV
void SystemScene::Update(void)
{
	SCENEMANAGER->JumpScene(new TextureTestScene);
#if defined(_DEBUG)
	if( INPUT->IsKeyPush(Input::Up) )
	{
		m_selectScene --;
}
	else if( INPUT->IsKeyPush(Input::Down) )
	{
		m_selectScene ++;
	}
	else if( INPUT->IsKeyPush(Input::A) )
	{
		SCENEMANAGER->JumpScene(m_ppSceneList[m_selectScene]);
	}

	if( m_selectScene < 0 )
	{
		m_selectScene = m_sceneNum - 1;
	}
	else if( m_selectScene == m_sceneNum )
	{
		m_selectScene = 0;
	}
#endif
}

// `
void SystemScene::Render(void)
{
#if false
	int X = 120;
	int Y = 120;
	for( int i=0; i < m_sceneNum; i++ )
	{
		bool isSelect = i == m_selectScene;
		DWORD color = 0xffffffff;
		if( isSelect )
		{
			color = 0xffff0000;
		}
		DEBUGFONT->DrawText(X, Y, color, m_ppSceneList[i]->GetName());
		Y += DEBUGFONT->GetHeight();
	}
#endif
}
