#include "DirectXLib/DirectXLib.h"
#include "TextureTestScene.h"
#include "SystemScene.h"


TextureTestScene::TextureTestScene(void)
{
}

TextureTestScene::~TextureTestScene(void)
{
}

// 
bool TextureTestScene::Initialize(void)
{
	// assetstH_bridge.pngeNX`[Ƃēǂݍ
	if (!m_texData.Load("assets/Dewprism.dds"))
	{
		return false;
	}

	// 摜TCY畝ƍݒ
	float rect[] =
	{
		10.0f, 10.0f,
		10.0f + (float)m_texData.GetSrcWidth(), 10.0f + (float)m_texData.GetSrcHeight(),
	};
	// eNX`[TCY摜TCYUV擾(摜2̗ݏł1.0fɂȂ)
	float u = (float)m_texData.GetSrcWidth() / (float)m_texData.GetWidth();
	float v = (float)m_texData.GetSrcHeight() / (float)m_texData.GetHeight();
	// 摜TCYɍ킹UVǉ_f[^
	const Simple2DVertex vertices[4] =
	{
		// 1ڂ̋`
		{ { rect[0], rect[1], 0.0f }, { 0.0f, 0.0f } },
		{ { rect[2], rect[1], 0.0f }, {    u, 0.0f } },
		{ { rect[0], rect[3], 0.0f }, { 0.0f,    v } },
		{ { rect[2], rect[3], 0.0f }, {    u,    v } },
	};

	// _obt@̐
	if( !m_vertexBuffer.Create(sizeof(vertices), vertices) )
	{
		return false;
	}

	return true;
}

// 
void TextureTestScene::Finalize(void)
{
	m_texData.Finalize();
	m_vertexBuffer.Finalize();
}

// XV
void TextureTestScene::Update(void)
{
	if( INPUT->IsKeyPush(Input::A) )
	{
		SCENEMANAGER->JumpScene(new SystemScene);
	}
}

// `
void TextureTestScene::Render(void)
{
	auto pDevice = DirectXLib::Instance.GetDirectX();
	auto& pCommandList = pDevice->GetCommandList();

	auto vertexView = m_vertexBuffer.GetView();
	vertexView.StrideInBytes = sizeof(Simple2DVertex);

	pCommandList->IASetPrimitiveTopology(D3D_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP);
	pCommandList->IASetVertexBuffers(0, 1, &vertexView);
	pCommandList->DrawInstanced(4, 1, 0, 0);
}
